﻿using NetworkBehaviourClasses;
using UnityEngine;

namespace Action
{
    public class ConnectRobotAction : RobotAction
    {
        private GameObject _cubeObject;
        private GameObject _playerObject;

        public ConnectRobotAction(GameObject playerObject, GameObject cubeObject)
        {
            _playerObject = playerObject;
            _cubeObject = cubeObject;
        }
        public override void doAction()
        {
            Movable playerMovable = _playerObject.GetComponent<Movable>();
            Movable cubeMovable = _cubeObject.GetComponent<Movable>();
            
            if (cubeMovable.isConnected)
            {
                playerMovable.Connect(cubeMovable.moveObject);    
            }
            else
            {
                GameObject moveObject = MapManager.Instance.CreateMoveObject();
                playerMovable.Connect(moveObject);
                cubeMovable.Connect(moveObject);
            }
        }
    }
}