﻿using NetworkBehaviourClasses;
using UnityEngine;

namespace Action
{
    public class LinkRobotAction : RobotAction
    {
        private GameObject _cube1, _cube2;

        public LinkRobotAction(GameObject cube1, GameObject cube2)
        {
            _cube1 = cube1;
            _cube2 = cube2;
        }
        public override void doAction()
        {
            Movable c1movable = _cube1.GetComponent<Movable>();
            Movable c2movable = _cube2.GetComponent<Movable>();

            if (!c1movable.isConnected && !c2movable.isConnected)
            {
                GameObject moveObject = MapManager.Instance.CreateMoveObject();
                c1movable.Connect(moveObject);
                c2movable.Connect(moveObject);
            }
            else if (c1movable.isConnected && c2movable.isConnected)
            {
                Transform transform = c1movable.moveObject.transform;
                
                while (transform.childCount > 0)
                {
                    GameObject child = transform.GetChild(0).gameObject;
                    child.GetComponent<Movable>().Connect(c2movable.moveObject);
                }
            }
            else
            {
                if (c1movable.isConnected)
                {
                    c2movable.Connect(c1movable.moveObject);
                }
                else
                {
                    c1movable.Connect(c2movable.moveObject);
                }
            }
        }
    }
}