﻿using NetworkBehaviourClasses;
using UnityEngine;

namespace Action
{
    public class RotateRobotAction : RobotAction
    {
        private GameObject _playerObject;
        private int _dir;
        
        public RotateRobotAction(GameObject playerObject, int dir)
        {
            _playerObject = playerObject;
            _dir = dir;
        }

        public override void doAction()
        { 
            Vector3Int playerPos = Vector3Int.RoundToInt(_playerObject.transform.position);
            GameObject moveObject = _playerObject.GetComponent<Movable>().moveObject;

            for (int i = 0; i < moveObject.transform.childCount; i++)
            {
                GameObject child = moveObject.transform.GetChild(i).gameObject;
                Vector3Int childPos = Vector3Int.RoundToInt(child.transform.position);

                int diffX = playerPos.x - childPos.x;
                int diffY = playerPos.y - childPos.y;
                if (diffX == 0 && diffY == 0) continue;

                Vector3 newPos = new Vector3(playerPos.x - (_dir * diffY), playerPos.y + (_dir * diffX), 0);
                child.transform.position = newPos;
            }
        }
    }
}