﻿using System;
using NetworkBehaviourClasses;
using UnityEngine;

namespace Action
{
    public class UnlinkRobotAction : RobotAction
    {

        private GameObject _cube1, _cube2;

        public UnlinkRobotAction(GameObject cube1, GameObject cube2)
        {
            _cube1 = cube1;
            _cube2 = cube2;
        }

        public override void doAction()
        {
            Movable movable = _cube1.GetComponent<Movable>();
            Transform moveObjectTransform = movable.moveObject.transform;
            Vector3Int c1Pos = Vector3Int.RoundToInt(_cube1.transform.position);
            Vector3Int c2Pos = Vector3Int.RoundToInt(_cube2.transform.position);
            
            bool divideByX = c1Pos.y == c2Pos.y;
            
            GameObject smaller;
            if (divideByX) { smaller = c1Pos.x < c2Pos.x ? _cube1 : _cube2; }
            else { smaller = c1Pos.y < c2Pos.y ? _cube1 : _cube2; }

            Vector3Int smallerPos = Vector3Int.RoundToInt(smaller.transform.position);
            GameObject newMoveObject = MapManager.Instance.CreateMoveObject();

            for (int i = 0; i < moveObjectTransform.childCount;)
            {
                GameObject child = moveObjectTransform.GetChild(i).gameObject;
                Vector3Int childPos = Vector3Int.RoundToInt(child.transform.position);
                
                if ((divideByX && childPos.x > smallerPos.x) || (!divideByX && childPos.y > smallerPos.y))
                {
                    Movable childMovable = child.GetComponent<Movable>();
                    childMovable.Disconnect();
                    childMovable.Connect(newMoveObject);
                }
                else
                {
                    i++;
                }
            }

        }
    }
}