using System.Collections.Generic;
using UnityEditor;
using UnityEngine;

namespace Model 
{
    public class OccupiedSpaces : MonoBehaviour
    {
        // private fields
        private List<Vector3> _occupiedSpaces;
        
        // Singleton Contructor
        public static OccupiedSpaces Instance { get; private set; }
        void Start()
        {
            if (Instance != null && Instance != this)
            {
              Destroy(gameObject);   
            }
            Instance = this;
        }

        // public methods
        public bool inOccupiedSpaces(Vector3 block)
        {
            return _occupiedSpaces.Contains(block);
        }

        public void addOccupiedBlock(Vector3 block)
        {
            if (!inOccupiedSpaces(block))
            {
                _occupiedSpaces.Add(block);
            }
        }

        public void removeBlock(Vector3 block)
        {
            if (inOccupiedSpaces(block))
            {
                _occupiedSpaces.Remove(block);
            }
        }
        
    }
}