using System;
using Unity.Netcode;
using UnityEngine;
using UnityEngine.Serialization;

namespace NetworkBehaviourClasses
{
    public class Cube : NetworkBehaviour
    {
        // serialized fields
        [SerializeField] private Sprite[] sprites;

        // private fields
        private SpriteRenderer _spriteRenderer;

        // public fields
        public static readonly int NColors = Enum.GetNames(typeof(CubeColor)).Length;
        public CubeColor color = CubeColor.Blue;

        // private methods
        private void Start()
        {
            _spriteRenderer = GetComponent<SpriteRenderer>();
            _spriteRenderer.sprite = sprites[(int)color];
        }

        // public methods

        [ClientRpc]
        public void SetColorClientRpc(CubeColor c)
        {
            this.color = c;
        }
    }

    public enum CubeColor
    {
        Red,
        Green,
        Blue,
        Yellow
    }
}