﻿using Unity.Netcode;
using Unity.VisualScripting;
using UnityEngine;
using UnityEngine.Serialization;

namespace NetworkBehaviourClasses
{
    public class Movable : NetworkBehaviour
    {
        public GameObject moveObject;
        public bool isConnected;
        private Movement _movement;
        [SerializeField] private SpriteRenderer highlightObject;
        private SpriteRenderer _highlight;

        private void Start()
        {
            moveObject = gameObject;
            isConnected = false;
            _movement = gameObject.GetComponent<Movement>();
            _highlight = highlightObject.GetComponent<SpriteRenderer>();
            _highlight.enabled = false;
        }
        public void Connect(GameObject obj)
        {
            moveObject = obj;
            gameObject.transform.parent = obj.transform;
            isConnected = true;
            SetHighlightClientRpc(true);

            if (_movement != null) _movement.SetIsEnabledClientRpc(false);
        }

        public void Disconnect()
        {
            GameObject go = gameObject;
            moveObject = go;
            go.transform.parent = null;
            isConnected = false;
            SetHighlightClientRpc(false);

            if (_movement != null)
            {
                _movement.movePoint = go.transform.position;
                _movement.SetIsEnabledClientRpc(true);
            }
        }

        [ClientRpc]
        private void SetHighlightClientRpc(bool val)
        {
            _highlight.enabled = val;
        }
    }
}