﻿using Unity.Netcode;
using UnityEngine;

namespace NetworkBehaviourClasses
{
    public class MoveObject : NetworkBehaviour
    {
        private Transform _transform;
        void Start()
        {
            _transform = gameObject.transform;
            GameManager.OnGameStateChanged += GameManagerOnGameStateChanged;
        }

        private void GameManagerOnGameStateChanged(GameState state)
        {
            if (state == GameState.Turn)
            {
                if (_transform.childCount < 2) Suicide();
            }
        }

        private void Suicide()
        {
            GameManager.OnGameStateChanged -= GameManagerOnGameStateChanged;
            
            while (_transform.childCount > 0)
            {
                GameObject child = _transform.GetChild(0).gameObject;
                child.GetComponent<Movable>().Disconnect();
            }

            gameObject.GetComponent<NetworkObject>().Despawn();
        }
    }
}