using System.Collections;
using System.Collections.Generic;
using NetworkBehaviourClasses;
using Unity.Netcode;
using UnityEngine;

public class Obstacle : NetworkBehaviour
{
    [SerializeField] private int maxHealth = 2;
    [SerializeField] private Sprite[] sprites;
    
    private SpriteRenderer _spriteRenderer;
    private int _health;

    public int Health { get { return _health; } }


    public void Awake()
    {
        _spriteRenderer = GetComponent<SpriteRenderer>();
        _health = maxHealth;
        _spriteRenderer.sprite = sprites[0];
    }

    public void Hit()
    {
        _health--;
        if (_health == 0)
        {
            Suicide();
        }
        else
        {
            UpdateSpriteClientRpc(maxHealth - _health);
        }
    }

    [ClientRpc]
    private void UpdateSpriteClientRpc(int index)
    {
        _spriteRenderer.sprite = sprites[index];
    }

    private void Suicide()
    {
        MapManager.Instance.KillMapObject(gameObject);
    }
}
