﻿using System;
using Unity.Netcode;
using UnityEngine;

namespace NetworkBehaviourClasses
{
    public class Player : NetworkBehaviour
    {
        // serialized fields
        [SerializeField] private Sprite[] sprites;

        // private fields
        private SpriteRenderer _spriteRenderer;

        // public fields
        public Team team;

        // private methods
        private void Start()
        {
            _spriteRenderer = GetComponent<SpriteRenderer>();
            _spriteRenderer.sprite = team == Team.Red ? sprites[0] : sprites[1];
        }

        // public methods

        [ClientRpc]
        public void SetTeamClientRpc(Team t)
        {
            team = t;
        }
        
    }
}