﻿using MultiPlayer;
using TMPro;
using UnityEngine;
using UnityEngine.Serialization;
using UnityEngine.UIElements;

namespace UI
{
    public class AuthenticateUI : MonoBehaviour
    {
        [SerializeField] private TMP_InputField input;
        [SerializeField] private GameObject lobby;
        [SerializeField] private GameObject mainMenu;
        [SerializeField] private GameObject backGround;
        [SerializeField] private GameObject newBackGround;

        /// <summary>
        /// Function to call when the Ok button is pressed
        /// </summary>
        public async void OnOkClick()
        {
            lobby.SetActive(true);
            gameObject.SetActive(false);
            mainMenu.SetActive(false);
            backGround.SetActive(false);
            newBackGround.SetActive(true);
            await Authentication.Instance.Authenticate(input.text);
        }

        /// <summary>
        /// Function to call when the Cancel button is pressed
        /// </summary>
        public void OnCancelClick()
        {
            gameObject.SetActive(false);
        }

    }
}