using UnityEngine;
using UnityEngine.EventSystems;

namespace UI
{
    public class DragWindow : MonoBehaviour , IDragHandler, IPointerDownHandler
    {

        private RectTransform _dragRectTransform;
        private Canvas _canvas;
        
        //Finds the rect transform of the parent object and finds the highest canvas
        private void Awake()
        {
            if (_dragRectTransform == null)
            {
                _dragRectTransform = transform.parent.GetComponent<RectTransform>();
            }

            if (_canvas == null)
            {
                Transform testCanvasTransform = transform.parent;
                while (testCanvasTransform != null)
                {
                    _canvas = testCanvasTransform.GetComponent<Canvas>();
                    if (_canvas != null)
                    {
                        break;
                    }

                    testCanvasTransform = testCanvasTransform.parent;
                }
            }
        }
        //Moves the objects when its drag
        public void OnDrag(PointerEventData eventData)
        {
            _dragRectTransform.anchoredPosition += eventData.delta / _canvas.scaleFactor;
        }

        //When we click down max the current object be the top one
        public void OnPointerDown(PointerEventData eventData)
        {
            _dragRectTransform.SetAsLastSibling();
        }
    }
}
