using System;
using UnityEngine;
using UnityEngine.UI;
using Model;
using UnityEngine.Serialization;

namespace UI.InputSystem
{
    public class InputButtonUI : MonoBehaviour
    {

        [SerializeField] private Button button;
        [SerializeField] private Image backGround;
        [SerializeField] private KeyCode inputCode;
        [SerializeField] private KeyCode inputCode2;
        [SerializeField] private Color selectedColor;
        [SerializeField] public Color baseColor;
        [FormerlySerializedAs("Type")] [SerializeField] public ActionType type;
        public bool IsSelected { get; set; }
        public event EventHandler SelectedEvent;

        private void Start()
        {
            button.onClick.AddListener(OnClick);
            backGround.color = baseColor;
        }

        void Update()
        {
            if (Input.GetKeyDown(inputCode) || Input.GetKeyDown(inputCode2))
            {
                IsSelected = true;
                SelectedEvent?.Invoke(this,EventArgs.Empty);
                
            }

            if (IsSelected)
            {
                backGround.color = selectedColor;
                button.enabled = false;
            }
            else
            {
                backGround.color = baseColor;
                button.enabled = true;
            }
            
        }

        private void OnClick()
        {
            IsSelected = true;
            SelectedEvent?.Invoke(this,EventArgs.Empty);
        }
    }
}
