﻿using System;
using System.Collections.Generic;
using MultiPlayer.LobbyScripts;
using NetworkBehaviourClasses;
using TMPro;
using Unity.Services.Lobbies;
using Unity.Services.Lobbies.Models;
using Unity.VisualScripting;
using UnityEngine;
using UnityEngine.UI;
using Player = Unity.Services.Lobbies.Models.Player;

namespace UI.LobbyScripts
{
    public class JoinedPlayerUI : MonoBehaviour
    {
        [SerializeField] private Team Team;
        [SerializeField] public Transform Switch;
        [SerializeField] private TextMeshProUGUI Name;
        private Player _player;

        public void Start()
        {
            //Switch teams method on the switch button
            Switch.GetComponent<Button>().onClick.AddListener(async () =>
            {
                    if (Team == Team.Red)
                    {
                        
                        try
                        {
                            UpdatePlayerOptions options = new UpdatePlayerOptions
                            {
                                Data = new Dictionary<string, PlayerDataObject>
                                {
                                    { "Team", new PlayerDataObject(PlayerDataObject.VisibilityOptions.Member, "Blue") }
                                }
                            };

                            await Lobbies.Instance.UpdatePlayerAsync(JoinedLobbyUI.Instance.Lobby.Id, _player.Id, options);
                            LobbyManager.Instance.joinedTeam = "Blue";
                        }
                        catch (Exception e)
                        {
                            Debug.LogException(e);
                        }
                    }
            

                    if (Team == Team.Blue)
                    {
                        
                        try
                        {
                            UpdatePlayerOptions options = new UpdatePlayerOptions
                            {
                                Data = new Dictionary<string, PlayerDataObject>
                                {
                                    {"Team",new PlayerDataObject(PlayerDataObject.VisibilityOptions.Member,"Red")}
                                }
                            };

                            await Lobbies.Instance.UpdatePlayerAsync(JoinedLobbyUI.Instance.Lobby.Id, _player.Id, options);
                            LobbyManager.Instance.joinedTeam = "Red";

                        }
                        catch (Exception e)
                        {
                            Debug.LogException(e);
                        }
                    }
                
            });
        }
        
        /// <summary>
        /// Sets up player displays
        /// </summary>
        /// <param name="player">The player to set up</param>
        public void SetUpPlayerStat(Player player)
        {
            _player = player;
            Name.text = player.Data["PlayerName"].Value;
        }
        
    }
}