using System;
using MultiPlayer.LobbyScripts;
using TMPro;
using Unity.Services.Lobbies.Models;
using UnityEngine;
using UnityEngine.UI;

namespace UI.LobbyScripts
{
    public class LobbyListUI : MonoBehaviour
    {
        [SerializeField] private Button joinButton;
        [SerializeField] private TextMeshProUGUI lobbyName;
        [SerializeField] private TextMeshProUGUI lobbyMaxPlayerNumber;
        [SerializeField] private GameObject teamChoosePrefab;
        private Lobby _lobby;

        public void Start()
        {
            joinButton.onClick.AddListener(() =>
            {

                GameObject teamChoosGameObject = Instantiate(teamChoosePrefab, transform.parent.parent);
                teamChoosGameObject.GetComponent<TeamChooseUI>().Lobby = _lobby;

            });
        }

        /// <summary>
        /// Displays lobby name and current/max players
        /// </summary>
        /// <param name="lobby">Lobby to display</param>
        /// <param name="getCanvas">Canvas that this object is on</param>
        public void UpdateLobby(Lobby lobby,Transform getCanvas)
        {
            this._lobby = lobby;
            lobbyName.text = lobby.Name;
            lobbyMaxPlayerNumber.text = $"{lobby.MaxPlayers - lobby.AvailableSlots}/{lobby.MaxPlayers}";
        }
    }
}
