﻿using System;
using MultiPlayer.LobbyScripts;
using Unity.Services.Lobbies.Models;
using UnityEngine;
using UnityEngine.Serialization;
using UnityEngine.UI;

namespace UI.LobbyScripts
{
    public class TeamChooseUI : MonoBehaviour
    {
        [FormerlySerializedAs("Red")] 
        [SerializeField] public Button red;
        [FormerlySerializedAs("Blue")] 
        [SerializeField] public Button blue;
        public Lobby Lobby;

        private void Awake()
        {
            //Adds Function to join team as Red
            red.onClick.AddListener(async () =>
            {
                Destroy(gameObject);
                Lobby = await LobbyManager.Instance.JoinLobby(Lobby,"Red");
                LobbyUI.Instance.gameObject.SetActive(false);
                JoinedLobbyUI.Instance.gameObject.SetActive(true);
                JoinedLobbyUI.Instance.SetUpUI(Lobby);
                
            });
                
            //Adds Function to join team as Blue
            blue.onClick.AddListener(async () =>
            {
                Destroy(gameObject);
                Lobby = await LobbyManager.Instance.JoinLobby(Lobby,"Blue");
                LobbyUI.Instance.gameObject.SetActive(false);
                JoinedLobbyUI.Instance.gameObject.SetActive(true);
                JoinedLobbyUI.Instance.SetUpUI(Lobby);
            });
        }
        
    }
}