﻿using System;
using NetworkBehaviourClasses;
using TMPro;
using UI.LobbyScripts;
using Unity.Netcode;
using UnityEngine;

namespace UI
{
    public class PointsUI : NetworkBehaviour
    {
        [SerializeField] private Team team;
        [SerializeField] private TextMeshProUGUI scoreText;
        private int _score = 0;

        private void Awake()
        {
            GameManager.OnPointsAdded += GameManagerOnPointsAdded;
        }

        private void GameManagerOnPointsAdded(Team team, int points)
        {
            if (team == this.team)
            {
                _score += points;
                UpdateTextClientRpc(_score.ToString());
            }
        }

        [ClientRpc]
        private void UpdateTextClientRpc(string text)
        {
            scoreText.text = text;
        }
    }

}