using System.Collections;
using System.Collections.Generic;
using NUnit.Framework;
using UnityEngine.SceneManagement;
using UnityEngine;
using UnityEngine.TestTools;

public class movement
{

    private GameObject testObject;
    private Movement robot;

    [SetUp]
    public void Setup()
    {
        testObject = GameObject.Instantiate(new GameObject());
        robot = testObject.AddComponent<Movement>();
    }

    [UnityTest]
    public IEnumerator MoveUp()
    {
        Vector3 startPos = robot.transform.position;
        Vector3 endPos = startPos + Vector3.up + Vector3.up;

        robot.MoveTo(Vector3.up);
        robot.MoveTo(Vector3.up);

        yield return new WaitForSeconds(1f);

        Assert.AreEqual(robot.transform.position, endPos);

    }

    [UnityTest]
    public IEnumerator MoveDown()
    {
        Vector3 startPos = robot.transform.position;
        Vector3 endPos = startPos + Vector3.down + Vector3.down;

        robot.MoveTo(Vector3.down);
        robot.MoveTo(Vector3.down);

        yield return new WaitForSeconds(1f);
        Assert.AreEqual(robot.transform.position, endPos);

    }

    [UnityTest]
    public IEnumerator MoveLeft()
    {
        Vector3 startPos = robot.transform.position;
        Vector3 endPos = startPos + Vector3.left + Vector3.left;

        robot.MoveTo(Vector3.left);
        robot.MoveTo(Vector3.left);

        yield return new WaitForSeconds(1f);
        Assert.AreEqual(robot.transform.position, endPos);

    }

    [UnityTest]
    public IEnumerator MoveRight()
    {
        Vector3 startPos = robot.transform.position;
        Vector3 endPos = startPos + Vector3.right + Vector3.right;

        robot.MoveTo(Vector3.right);
        robot.MoveTo(Vector3.right);

        yield return new WaitForSeconds(1f);
        Assert.AreEqual(robot.transform.position, endPos);

    }

    [UnityTest]

    public IEnumerator MovesChained()
    {
        Vector3 startPos = robot.transform.position;

        robot.MoveTo(Vector2.left);

        yield return new WaitForSeconds(1f);

        Assert.AreEqual(robot.transform.position, startPos + Vector3.left);

        robot.MoveTo(Vector3.right);

        yield return new WaitForSeconds(1f);

        Assert.AreEqual(robot.transform.position, startPos);

    }



    [TearDown]
    public void TearDown()
    {
        GameObject.Destroy(testObject);
    }

}
